SystemOrganization addCategory: #'Pier-Randomizer'!

PRWidget subclass: #PRRandomizer
	instanceVariableNames: 'candidates current'
	classVariableNames: 'NoChildrenFound'
	poolDictionaries: ''
	category: 'Pier-Randomizer'!

!PRRandomizer classSide methodsFor: 'accessing-descriptions' stamp: 'lr 4/10/2008 14:17'!
descriptionKeep
	^ MABooleanDescription new
		comment: 'Keep the same random child during the lifetime of a session';
		accessor: #keep;
		default: true;
		priority: 100;
		label: 'Keep';
		yourself! !

!PRRandomizer classSide methodsFor: 'initialization' stamp: 'lr 6/7/2007 23:28'!
initialize
	NoChildrenFound := PRPage named: 'unnamed'.
	NoChildrenFound
		contents: 'Please add children to this widget'! !

!PRRandomizer classSide methodsFor: 'testing' stamp: 'lr 6/7/2007 22:44'!
isAbstract
	^ false! !

!PRRandomizer classSide methodsFor: 'accessing' stamp: 'lr 6/7/2007 22:44'!
label
	^ 'Randomizer'! !

!PRRandomizer methodsFor: 'accessing' stamp: 'lr 5/26/2009 18:28'!
candidates
	"Answer the possible candidates to display."

	^ candidates ifNil: [ candidates := self owner enumerator contents ]! !

!PRRandomizer methodsFor: 'accessing' stamp: 'lr 7/14/2009 21:04'!
children
	^ self current componentsIn: self context! !

!PRRandomizer methodsFor: 'accessing' stamp: 'lr 9/12/2007 18:18'!
current
	"Answer the current structure to display."

	(current isNil or: [ (self read: #descriptionKeep) not ]) ifTrue: [
		current := self candidates isEmpty
			ifFalse: [ self candidates atRandom ]
			ifTrue: [ NoChildrenFound ] ].
	^ current! !

!PRRandomizer methodsFor: 'rendering' stamp: 'lr 4/8/2009 20:14'!
renderContentOn: html
	html rendererInstance visit: self current document! !
PRRandomizer initialize!
